const db = require("quick.db");

module.exports = {
  name: "resetwarns",
  aliases: ["rwarns", "rsetwarns"],
  category: "moderation",
  usage: "rwarns <@user>",
  description: "Warnungen der erwähnten Person zurücksetzen",
  run: async (client, message, args) => {
    if (!message.member.hasPermission("ADMINISTRATOR")) {
      return message.channel.send(
        "Yopu sollte Administratorrechte haben, um diesen Befehl zu verwenden"
      );
    }

    const user = message.mentions.members.first();

    if (!user) {
      return message.channel.send("Bitte erwähnen Sie die Person, deren Warnung Sie zurücksetzen möchten");
    }

    if (message.mentions.users.first().bot) {
      return message.channel.send("Bot dürfen keine Warnungen haben");
    }

    if (message.author.id === user.id) {
      return message.channel.send("Sie sind nicht berechtigt, Ihre Warnungen zurückzusetzen");
    }

    let warnings = db.get(`Warnungen_${message.guild.id}_${user.id}`);

    if (warnings === null) {
      return message.channel.send(`${message.mentions.users.first().username} habe keine Warnungen`);
    }

    db.delete(`Warnungen_${message.guild.id}_${user.id}`);
    user.send(
      `Alle Ihre Warnungen werden von ${message.author.username} von ${message.guild.name} zurückgesetzt`
    );
    await message.channel.send(
      `Alle Warnungen von ${message.mentions.users.first().username} zurückgesetzt`
    );
  }
};
